#ifndef MOTO_H
#define MOTO_H
#include "Circuito.h"
#include "global.h"

struct Moto {

	real gears[7];
	int cur_gear;
	
	int idx; // indice en data->bikes
	
	int ignore_time; // tiempo en el cual no se choca con nada y parpadea (despues de un golpe)
	
	int crash_fase;
	
	int wheelie;
	int last_drawed_style;
	
	bool snd_engine_playing;
	bool snd_pasto_playing;
	bool snd_marca_playing;
	Sound snd_engine, snd_crash, snd_hit;
	bool hit, hitted;
	
	int clock_lap, clock_total;
	real times_last_partials[100]; // tiempo total hasta pasar por ultima vez por cada checkpoint, para calcular las diferencias con otros pilotos
	real times_avg_partials[100]; // suma por parciales, al final de la carrera se divide y se usa para proyectar lo que falto
	real time_last_lap; // tiempo de la ultima vuelta
	real time_last_check; // tiempo total hasta el ultimo check que paso, auxiliar para calcular los promedios
	real time_total; // tiempo total de carrera
	int pos, last_pos, new_pos, pos_stab;
	int last_dodge;
	string name;
	
	Color minicolor;
	Image image;
	Image image_c;
	Sprite sprite;
	Sprite sprite_c;
	Sprite sprite_s;
	Sprite sprite_l;
	IntRect *frames;
	int cayendo;
	real inclinacion, velocidad, direccion, accel, tiron;
	real max_vel,limit_vel,max_incl,max_accel,/*min_accel,*/ brake, roce, prop_tiron;
	real min_inclinacion, max_inclinacion, min_vel;
	real vel_max_inclinacion, vel_min_inclinacion;
	int fbdown; // cuantos frames hace que tiene el freno apretado (para el bloqueo)
	int last_inc; // signo de la ultima inclinacion no nula
	real x,y,dr,dx,dy,drx,dry;
	bool crash;
	real c_xm,c_ym,c_dm,c_am,c_vm;
	real c_xp,c_yp,c_dp,c_ap,c_vp;
	int fnum,lfnum;
	int accel_time, noaccel_time, last_power; // para el power_slide
	real delta_power_slide;
	bool power_slide;
	
	int route_next, check_next; real route_alpha, route_ideal_alpha, route_last_alpha; int num_op_close;
	int route_next_v2; real route_alpha_v2;
	int lap; int check_dist, festejo, festejo_aux, festejo_f;
	bool lap_done, im_done, first_target;
	real target_x,target_y;
	real target_x_v2,target_y_v2;
	
	int controller;
	bool key_accel, key_fake_accel;
	bool key_brake;
	bool key_left;
	bool key_right;
	real drafting;
	int draft_time;
	int qp_rueda1, qp_rueda2;
	real limit_inclinacion;
	
	real vangle,rangle;
	
	real target_cam_x, target_cam_y, target_cam_z;
	Moto(const Racer &racer);
//	Moto(string aname, string file, string file2, pos_largada pos, int acontroller,
//		int level_accel, int level_brake, int level_tiron, int level_vel);
	
	~Moto();
	
	void Control();
	
	void Vuelta();
	
	void Update(bool draw=true);
	
	void DoSound();
	void Mute();

};

extern Moto *motos[bike_max];
extern Moto *moto_target;

#endif

