#ifndef PROFILE_H
#include <string>
#include "global.h"
using namespace std;
#define PROFILE_H

struct Profile {
	string file,name;
	int tips_seen; // el 1 es cuando empieza el campeonato, de 2 a 9 son los tips
	int avail_tracks; // nro de tracks desbloqueados
	int bike;
	Profile(string afile);
	~Profile();
	int accel,brake,turn,vel;
	real best_lap[track_max];
	int pts[track_max];
	real temp_best_lap; // para comparar durante la carrera, guarda temporalmente el del circuito actual
	bool changed;
	bool on_championship;
	void LoadChampionshipData();
	void RetireFromChampionship();
	void SetRecord(string id, real t);
	void Save(bool forced=false);
	int GetPoints();
	int UpdatePoints(int track_num, int level, int pos);
	void ChangeBike(int cred_vel, int cred_accel, int cred_brake, int cred_turn, int bike);
};

extern Profile *profile;

#endif

